/*
Название: MakeGuidesAI.jsx
Приложение для использования: Adobe Illustrator CS3, CS4, CS5
Версия: 1.0
Язык реализации (Среда): JavaScript (ExtendScript Toolkit 2)
Операционные системы (Платформы): PC, Macintosh (Windows, Mac OS)
Условия распространения: Бесплатно; На Ваш риск
Назначение: Создание, перемещение, выделение, удаление направляющих
Функциональные ограничения: Не работает с выделенными направляющими
Техническая поддержка: Sergey-Anosov@yandex.ru
=================================================================
Name: MakeGuidesAI.jsx
Application to use with: Adobe Illustrator CS3, CS4, CS5
Version: 1.0
Program language (Environment): JavaScript (ExtendScript Toolkit 2)
Operating systems (Platforms): PC, Macintosh (Windows, Mac OS)
Distribution conditions: Freeware; At your own risk
Functions: Makes, moves, selects, deletes guides
Functional limitations: Can not process selection containing guides
Technical support: Sergey-Anosov@yandex.ru
*/
// описание глобальных переменных
var the_title = "Make Guides AI";
var the_version = "1.0";
var AD; // активный док-т
var AL; // активный слой
var SL; // выбранный слой
var SL_visible, SL_locked;
var AD_height = 0.; // высота активного док-та
var AD_width = 0.; // ширина активного док-та
var the_sel; // выделение в акт. док-те
var sel_init;
// границы
var v_sel_left = new Array();//левые границы выделения объектов
var g_sel_left = new Array();//левые границы выделения объектов
var v_sel_right = new Array();//правые границы выделения объектов
var g_sel_right = new Array();//правые границы выделения объектов
var v_sel_top = new Array();//верхние границы выделения объектов
var g_sel_top = new Array();//верхние границы выделения объектов
var v_sel_bottom = new Array();// нижние границы выделения объектов
var g_sel_bottom = new Array();// нижние границы выделения объектов
// для границ объектов c учетом клип. масок
var NC_v_left = new Array();
var NC_g_left = new Array();
var NC_v_top = new Array();
var NC_g_top = new Array();
var NC_v_right = new Array();
var NC_g_right = new Array();
var NC_v_bottom = new Array();
var NC_g_bottom = new Array();
// наличие клип. масок влияющих на выделение
var CLIP = false;
var NO_CLIP_OBJ_TO_SHOW = new Array();
// делать с учетом клип. масок
var MAKE_BY_CLIP = false;
//
var N_sel = 0; // кол-во объектов в выделении
var N_doc = 0; //  кол-во док-тов в иллюстраторе
var dlg; // основной диалог
var the_geometric_bounds = true;// расчет по геом. разм если истина, если ложь то по виз.
var the_artboard_offset = "50";
var BLEED_VAL;
var dy_rulers_top = 0.;// смещение по вертикали (верх)
var dy_rulers_bottom = 0.;// смещение  по вертикали (низ)
var dx_rulers_left = 0.;// смещение по горизонтали (лево)
var dx_rulers_right = 0.;// смещение по горизонтали (право)
var AD_old_ruler_origin ;// старые настройки для сохранения
var AD_old_page_origin;// старые настройки для сохранения
// объекты для построения напр.
var MAKE_WHOLE_SEL = false;
var MAKE_EACH_OBJ = false;
var MAKE_ARTBOARD = false;
var BL = "\n";// первод строки
var exit_if_bad_input = false;
var exit_if_bad_sel = false;
// сдвиги для направляющих из диалога
var SHIFT_LEFT, SHIFT_RIGHT, SHIFT_TOP, SHIFT_CV, SHIFT_CH, SHIFT_BOTTOM;
var dlg_LEFT, dlg_RIGHT, dlg_TOP, dlg_CV, dlg_CH, dlg_BOTTOM;
// создавать копии направляющих
var COPY;
// наличие ненулевого сдвига
var NON_ZERO_SHIFT = false;
// единицы измерения
var UNITS = "mm";
var BLEED_UNITS;
// выбор д диалоге
var OBJ_DROP, UNITS_DROP, BOUNDS_DROP, LAYER_DROP, MOVE_ALL_GUIDES;
// заблокированность слоев
var LL = new Array();
// видимость слоев
var LV = new Array();
// не было операции
var NO_OPERATION = false;
// выделить все направляющие
var SEL_ALL_GUIDES;
// удалить направляющие
var DEL_GUIDES;
// где удалять
var DEL_WHERE;
// удалять заблокированные направляющие
var DEL_LOCKED;
var LOCKED_GUIDES, LOCKED_LAYERS;
// не закрывать выбранный слой
var NO_CLOSE_SL = false;
// слои открывались
var LAYERS_WERE_OPEN = false;
// кол-во перемещенных напр.
var N_MOVED = 0;
// кол-во удаленных напр.
var N_DEL = 0;
// кол-во выделенных напр.
var N_SELECTED = 0;
// выполнено успешно
var DONE_OK = true;
// кол-во созданных напр.
var N_MADE = 0;
// выбранные направления
var DIR_SELECTED;
// симметричный сдвиг
var SYM_BLEED;
var SYM_SHIFT = false;
var SYM_BLEED_TEXT_1, SYM_BLEED_TEXT_2;
//
var CM_OLD;
// успешный ввод
INP_OK = true;
// окно диалога для ожидания
var WAIT_WINDOW;
// нет док-тов
var NO_DOC = false;
//
// вызов главной подпрограммы
main();
// окончание выполнения скрипта :)))
//
// блок описания подпрограмм
// основная подпрограмма
function main () {
// вызываем проверку док-та и выделения
if ( CHECK_SELECTION()) {
	// если в порядке выделение и док-т:
	//создаем диалог
	dlg = new Window('dialog');
	dlg.text = the_title + " v." +the_version; // заголовок диалога
	dlg.childrenAlignment = 'center';
	// создание панели чекбоксов для выбора вариантов по направлению
	// для создания создания направляющих
	dlg.mainpanel = dlg.add('panel');
	var mp_left = 5;
	var mp_top = 0;
	var mp_right = 380;
	var mp_bottom = 230;
	dlg.mainpanel .bounds = [mp_left, mp_top, mp_right, mp_bottom];
	var mp_txt = dlg.mainpanel.add('statictext');
	mp_txt.text = "Directions";
	var dir_txt_left = mp_left;
	var dir_txt_right = dir_txt_left+80;
	var dir_txt_top = mp_top+10;
	var dir_txt_bottom = dir_txt_top+15;
	mp_txt.bounds = [dir_txt_left, dir_txt_top, dir_txt_right, dir_txt_bottom];
	mp_txt = dlg.mainpanel.add('statictext');
	mp_txt.text = "and shifts:";
	mp_txt.bounds = [dir_txt_left, dir_txt_bottom+3, dir_txt_right, dir_txt_bottom+50];
	// кнопка очистить направления
	var BUTTON_H = 20;
	var BUTTON_W = 100;
	var CD_left = 250,  CD_top = 17;
	var CD_right = CD_left + BUTTON_W;
	var CLEAR_DIR = dlg.mainpanel.add('button');
	CLEAR_DIR.onClick = CLEAR_DIR_ON_CLICK;
	CLEAR_DIR.text = "Clear directions";
	CLEAR_DIR.bounds = [CD_left, CD_top, CD_right, CD_top+BUTTON_H];
	// кнопка очистить сдвиги
	var CLEAR_SHIFTS = dlg.mainpanel.add('button');
	CLEAR_SHIFTS.onClick = CLEAR_SHIFTS_ON_CLICK
	CLEAR_SHIFTS.text = "Clear shifts";
	var CSH_left = CD_left+10;
	var CSH_right = CSH_left+BUTTON_W-30;
	var CSH_top = 190;
	CLEAR_SHIFTS.bounds = [CD_left+20, CSH_top, CD_right, CSH_top+BUTTON_H];
	//назначаем параметры чекбоксов
	var button_width =  90; // ширина чекбокса
	var button_height = 25; // высота чекбокса
	var digit_width = 45; // ширина поля для цифры
	var digit_height = 22;// высота поля для цифры
	// назначаем начальные координаты для привязки
	var dx = 5; // зазор по горизонтали
	var dy = 10; // зазор по вертикали
	var left_0 = 5;// самое левое положение
	var top_0 = 15;// самое верхнее положение
	// общие габариты блока
	var B_C_W = button_width + digit_width;// ширина
	var B_C_H =  button_height + digit_height;// высота
	//
	function SHIFT_CHECKBOX (x, y, the_text, text_bottom, text_len) 
	{
		// положение окна для ввода цифры
		var d_dy = 2;
		var digit_left = x;
		var digit_top = y+d_dy;
		var digit_right = digit_left + digit_width;
		var digit_bottom = digit_top+digit_height;
		var digit = dlg.mainpanel.add('edittext');
		digit.text = "0";
		digit.bounds = [digit_left, digit_top, digit_right, digit_bottom];
		// единицы измерения
		var UNITS_CB = dlg.mainpanel.add('statictext');
		UNITS_CB.bounds = [digit_right+2, digit_top+3, digit_right+25, digit_bottom+3];
		UNITS_CB.text =GET_ACTIVE_UNITS()[0];
		// положение чекбокса
		var cb_left = x+digit_width+25;
		var cb_top = y;
		var cb_right = x+digit_width+button_width;
		var cb_bottom = y+button_height;
		var cb = dlg.mainpanel.add('checkbox');
		cb.text = the_text;
		cb.bounds = [cb_left, y, cb_left+text_len, cb_bottom];
		// ставим подсказки ВНИЗУ - и +
		var minus = dlg.mainpanel.add('statictext');
		var plus = dlg.mainpanel.add('statictext');
		minus.text = '-';
		plus.text = '+';
		var m_left = x;
		var m_right = m_left+10;
		var m_top = y+digit_height+d_dy;
		var m_bottom = m_top +20 ;
		if( text_bottom ) {
			var p_left = x + digit_width - 10;
			var p_top = m_top;
			var p_right = p_left + 15;
			var p_bottom = m_top + 20;
		} else {
			var p_left = m_left;
			var p_top = m_top - digit_height -15;
			var p_right = p_left + 15;
			var p_bottom = p_top +15;	
		}
		minus.bounds = [m_left, m_top, m_right, m_bottom];
		plus.bounds = [p_left, p_top, p_right, p_bottom];	
		//
		digit.onChanging = digit_on_Changing;
		digit.onChange = digit_on_Change;
		// подпрограмма процесса ввода
		function digit_on_Changing() 
		{
			INP_OK = true;
			var d;
			//
			cb.value = true;
			var s = GET_NUMBER_ON_INPUT(digit.text);
			if(exit_if_bad_input)
			{
				digit.text = "0";
				digit.text.selected = true;
				digit.active = true;
				INP_OK = false;
			}
			cb.value = true;
			var ARR_CB = [dlg_LEFT, dlg_TOP, dlg_RIGHT, dlg_BOTTOM];
			if( SYM_SHIFT ) 
			{
				for( var i = 0; i < ARR_CB.length; i++ ) 
				{
					var CB = ARR_CB[i];
					if( CB[0].active ) 
					{
						var CB_ACT = CB;
						d = parseFloat(  TEXT_TO_DIGIT(CB[0].text) );
						if( isNaN( d ) ) d = 0;
						d = d + "";
						var d_minus = ( -1. * d ) + "";
						// лево
						if( CB_ACT == dlg_LEFT ) 
						{
							dlg_TOP[0].text = dlg_RIGHT[0].text = d_minus;
							dlg_BOTTOM[0].text = d;
						};
						// верх
						if( CB_ACT == dlg_TOP ) 
						{
							dlg_LEFT[0].text = dlg_BOTTOM[0].text = d_minus;
							dlg_RIGHT[0].text = d;
						};
						// право
						if( CB_ACT == dlg_RIGHT ) 
						{
							dlg_LEFT[0].text = dlg_BOTTOM[0].text = d_minus;
							dlg_TOP[0].text = d;
						};
						// низ
						if( CB_ACT == dlg_BOTTOM ) 
						{
							dlg_TOP[0].text = dlg_RIGHT[0].text = d_minus;
							dlg_LEFT[0].text = d;
						};
						for(var j=0; j < ARR_CB.length; j++) 
						{
							var CB_j = ARR_CB[j];
							if( CB_j == CB_ACT ) continue;
							CB_j[1].value = CB_ACT[1].value;
						};// for j
					};// if
				};// for i
			};// if
		if(digit.text == "") { digit.text = "0"; digit.text.selected = true };
		if(digit.text == " ") { digit.text = "0"; digit.text.selected = true };
		if( !DIR_CHECKED() ) {
			COPY.enabled= COPY.value = false;
		} else {
			COPY.enabled = true;
		};// if-else
		return;
		};// end digit_on_Changing
		//
		function digit_on_Change() 
		{
			function CB_FALSE() 
			{
				if( !( SYM_SHIFT) ) cb.value = false;
			};
			var txt = digit.text;
			if( txt == ""  ||
				txt == " " ||
				txt == "-" ||
				txt == "+"||
				txt == "." ||
				txt == "," ||
				exit_if_bad_input ||
				!INP_OK ) { digit.text = "0"; digit.text.selected = true };
			if( isNaN( parseFloat (TEXT_TO_DIGIT (digit.text)) ) ) 
			{
				digit.text = "0";
				digit.text.selected = true;
				return;
			};// if
			if( parseFloat (TEXT_TO_DIGIT (digit.text)) == 0. ) 
			{
				digit.text = "0";
			};// if			
			if( parseFloat (TEXT_TO_DIGIT (digit.text)) != 0. ) cb.value = true;
			digit.text = parseFloat (TEXT_TO_DIGIT (digit.text));
			if( cb.value ) COPY.enabled = true;
		return;
		};// end digit_on_Change
		//
		cb.onClick = cb_on_Click;
		function cb_on_Click() 
		{
			if( !cb.value ) 
			{
				digit.text = "0";
				digit.active = false;
				if( SYM_SHIFT ) 
				{
					if( !dlg_LEFT[1].value || !dlg_TOP[1].value || !dlg_RIGHT[1].value || !dlg_BOTTOM[1].value) 
					{
						SYM_BLEED.value = false;
						SYM_SHIFT = false;
					};// if
				};// if
			};// if
		cb_on_Change();
		return
		};// end cb_on_Click
		//
		function cb_on_Change() 
		{
			if( !DIR_CHECKED()) 
			{
				COPY.enabled = COPY.value = false;
			} else {
				COPY.enabled = true;
			};// if-else
			return;
		};// end cb_on_Change
		//
		return [digit, cb, minus, plus, UNITS_CB];
	};// end SHIFT_CHECKBOX
	//  строим панель чекбоксов
	// лево
	var left_x = left_0; var left_y = 97-3;
	dlg_LEFT = SHIFT_CHECKBOX (left_x, left_y, "Left", true, 50);
	// верх
	var top_x = B_C_W-10; var top_y = top_0;
	dlg_TOP = SHIFT_CHECKBOX ( top_x, top_y, "Top", false,50);
	// центр вертикаль
	var cv_x = top_x; var cv_y = top_y + B_C_H+dy;
	dlg_CV = SHIFT_CHECKBOX (cv_x, cv_y, "Center Vertical", true, 110);
	// центр горизонт
	var ch_x = top_x; var ch_y = cv_y + B_C_H+dy;
	dlg_CH = SHIFT_CHECKBOX (ch_x, ch_y, "Center Horizontal", false,115);
	// низ
	var bottom_x = top_x; var bottom_y = ch_y + B_C_H+dy;
	dlg_BOTTOM = SHIFT_CHECKBOX (bottom_x, bottom_y, "Bottom", false,100);
	// право
	var right_x = top_x +B_C_W-10; var right_y = left_y;
	dlg_RIGHT = SHIFT_CHECKBOX (right_x, right_y, "Right", true,70);
	//
	// подпрограмма нажатия на очистку направлений
	function CLEAR_DIR_ON_CLICK(){
		dlg_LEFT[1].value=dlg_TOP[1].value=dlg_RIGHT[1].value=dlg_BOTTOM[1].value=dlg_CV[1].value=dlg_CH[1].value= false;
		dlg_LEFT[0].text=dlg_TOP[0].text=dlg_RIGHT[0].text=dlg_BOTTOM[0].text=dlg_CV[0].text=dlg_CH[0].text= "0";
		COPY.enabled = COPY.value = false;
		SYM_BLEED.value = false;
		SYM_SHIFT = false;
	return;
	};// end CLEAR_DIR_ON_CLICK
	//
	// подпрограмма нажатия на очистку сдвигов
	function CLEAR_SHIFTS_ON_CLICK()
	{
		dlg_LEFT[0].text=dlg_TOP[0].text=dlg_RIGHT[0].text=dlg_BOTTOM[0].text=dlg_CV[0].text=dlg_CH[0].text= "0";
	return;
	};// end CLEAR_SHIFTS_ON_CLICK
	//
	// подпрограмма проверки: есть ли направления
	function DIR_CHECKED() 
	{
		if( !dlg_LEFT[1].value && !dlg_TOP[1].value && !dlg_RIGHT[1].value && !dlg_BOTTOM[1].value && !dlg_CV[1].value && !dlg_CH[1].value ) {
			return false
		} else {
			return true
		};// if-else
	};// end DIR_CHECKED
	//
	// чекбокс для симметричных отступов
	SYM_BLEED = dlg.mainpanel.add('checkbox');
	SYM_BLEED.onClick = SYM_BLEED_onClick;
	function SYM_BLEED_onClick()
	{
		if( SYM_BLEED.value ) SYM_SHIFT = true;
		if( !SYM_BLEED.value ) SYM_SHIFT = false;
		var ARR_CB = [dlg_LEFT, dlg_TOP, dlg_RIGHT, dlg_BOTTOM];
		if( SYM_SHIFT ) 
		{
			dlg_LEFT[1].value=dlg_TOP[1].value=dlg_RIGHT[1].value=dlg_BOTTOM[1].value= true;
			var ACT = false;
			for( var i=0; i < ARR_CB.length; i++) 
			{
					var CB = ARR_CB[i];
					if( CB[0].active ) {
						var CB_ACT = CB;
						ACT = true;
						d = parseFloat(  TEXT_TO_DIGIT(CB[0].text) );
						if( isNaN( d ) ) d = 0;
						d = d + "";
						var d_minus = ( -1. * d ) + "";
						// лево
						if( CB_ACT == dlg_LEFT ) 
						{
							dlg_TOP[0].text = dlg_RIGHT[0].text = d_minus;
							dlg_BOTTOM[0].text = d;
						};
						// верх
						if( CB_ACT == dlg_TOP ) 
						{
							dlg_LEFT[0].text = dlg_BOTTOM[0].text = d_minus;
							dlg_RIGHT[0].text = d;
						};
						// право
						if( CB_ACT == dlg_RIGHT ) 
						{
							dlg_LEFT[0].text = dlg_BOTTOM[0].text = d_minus;
							dlg_TOP[0].text = d;
						};
						// низ
						if( CB_ACT == dlg_BOTTOM ) 
						{
							dlg_TOP[0].text = dlg_RIGHT[0].text = d_minus;
							dlg_LEFT[0].text = d;
						};
					};// if
			};// for i
			if( !ACT ) 
			{
				dlg_LEFT[0].text=dlg_TOP[0].text=dlg_RIGHT[0].text=dlg_BOTTOM[0].text= "0";
			};// if
		COPY.enabled = true;
		};// if SYM_SHIFT
		return;
	};// end SYM_BLEED_onClick
	var sym_bleed_x = left_x;
	var sym_bleed_y = bottom_y;
	SYM_BLEED.bounds = [sym_bleed_x, sym_bleed_y, sym_bleed_x+20, sym_bleed_y+button_height];
	var SYM_BLEED_TEXT_1 = dlg.mainpanel.add('statictext');
	var sym_bleed_t1_top = sym_bleed_y -3;
	var sym_bleed_t1_bottom = sym_bleed_t1_top +15;
	SYM_BLEED_TEXT_1.bounds = [sym_bleed_x+21, sym_bleed_t1_top, sym_bleed_x+110, sym_bleed_t1_bottom];
	SYM_BLEED_TEXT_1.text = "Symmetric shifts";
	var sym_bleed_t2_top = sym_bleed_t1_bottom+3;
	var sym_bleed_t2_bottom = sym_bleed_t2_top +button_height;
	var SYM_BLEED_TEXT_2 = dlg.mainpanel.add('statictext');
	SYM_BLEED_TEXT_2.bounds = [sym_bleed_x+21, sym_bleed_t2_top, sym_bleed_x+110, sym_bleed_t2_bottom];
	SYM_BLEED_TEXT_2.text = "around object(s)";
	//
	function MAKE_DROP(where, the_text, the_list) 
	{
		var the_group = where.add('group');
		the_group.orientation = 'row';
		var txt = the_group.add('statictext');
		txt.text = the_text;
		var the_drop = the_group.add('dropdownlist');
		the_drop.maximumSize.width = 70;
		for( var i=0; i < the_list.length; i++ ) 
		{
			the_drop.add('item', the_list[i]);
		};// for
		the_drop.selection = 0;
		return the_drop;
	};// end MAKE_DROP
	//
	// создаем панель выбора границ объектов - геометрические или визуальные
	dlg.B_panel = dlg.add('group');
	dlg.B_panel.orientation = 'row';
	// 1 ряд
	// создаем панель выбора объектов для построения
	if(N_sel > 1) 
	{
		OBJ_DROP = MAKE_DROP(dlg.B_panel, "Objects:", ["Entire selection", "Each object in selection", "Artboard"]);
	}
	if(N_sel == 1) 
	{
		OBJ_DROP = MAKE_DROP(dlg.B_panel, "Objects:", ["Selected object", "Artboard"]);
	}
	if(N_sel == 0) 
	{
		MAKE_ARTBOARD = true;
		OBJ_DROP = MAKE_DROP(dlg.B_panel, "Object:", ["Artboard"]);
	}
	OBJ_DROP.onChange = OBJ_DROP_ON_CHANGE;
	//
	function OBJ_DROP_ON_CHANGE() 
	{
		if( N_sel != 0) 
		{
			if( OBJ_DROP.selection.text == "Artboard" ) 
			{
				DROP_ACTIVE( BOUNDS_DROP, false );
			} else {
				DROP_ACTIVE( BOUNDS_DROP, true );
			};// if-else
		};// if
	return;
	};// end OBJ_DROP_ON_CHANGE
	// группа для границ
	if( N_sel != 0 ) 
	{
		BOUNDS_DROP = MAKE_DROP(dlg.B_panel, "Bounds:", ["Geometric", "Visible"]);
	};// if
	//
	// группа для единиц
	UNITS_DROP = MAKE_DROP(dlg.B_panel, "Units:", ["mm", "cm", "pt", "in"]);
	UNITS_DROP.selection = GET_ACTIVE_UNITS()[1];
	UNITS_DROP.onChange = UNITS_DROP_ON_CHANGE;
	function UNITS_DROP_ON_CHANGE()
	{
		var UNITS_CB_TEXT = UNITS_DROP.selection.text;
		dlg_LEFT[4].text = dlg_RIGHT[4].text = 
		dlg_TOP[4].text = dlg_BOTTOM[4].text = 
		dlg_CV[4].text = dlg_CH[4].text = 
		BLEED_UNITS.text =
		UNITS_CB_TEXT;
		if(UNITS_CB_TEXT == "mm") the_artboard_offset = "50";
		if( UNITS_CB_TEXT == "cm") the_artboard_offset = "5";
		if( UNITS_CB_TEXT == "in") the_artboard_offset = "2";
		if( UNITS_CB_TEXT == "pt") the_artboard_offset = "100";
		if( UNITS_CB_TEXT == "N/A") the_artboard_offset = "0";
		BLEED_VAL.text = the_artboard_offset;
		return;
	}
	//
	// 2 ряд
	dlg.B_panel_2 = dlg.add('group');
	dlg.B_panel_2.orientation = 'row';
	//
	// выбор слоев
	if( AD.layers.length > 1 ) {
		var LAYERS_LIST = new Array();
		var LAYER_SEL
		for( var i=0; i < AD.layers.length; i++ ){
			LAYERS_LIST[i] = AD.layers[i].name;
			if( AD.layers[i] == AL ) LAYER_SEL = i;
		};// for
		LAYERS_DROP = MAKE_DROP(dlg.B_panel_2, "Layer:", LAYERS_LIST );
		LAYERS_DROP.selection = LAYER_SEL;
	};// if
	// создание окна ввода вылета за артборд
	//
	dlg.bleed_pan = dlg.B_panel_2.add('group');
	var BLEED_TEXT = dlg.bleed_pan.add('statictext');
	BLEED_TEXT.text = "Bleed beyond artboard:";
	BLEED_VAL = dlg.bleed_pan.add('edittext');
	BLEED_VAL.preferredSize = [45, digit_height];
	BLEED_VAL.text = the_artboard_offset;
	BLEED_VAL.onChanging = BLEED_VAL_ON_CHANGING;
	BLEED_VAL.onChange = BLEED_VAL_ON_CHANGE;
	// единицы для вылета
	BLEED_UNITS = dlg.bleed_pan.add('statictext');
	BLEED_UNITS.preferredSize = [25, 17];
	BLEED_UNITS.text = GET_ACTIVE_UNITS()[0];
	// подпрограмма возврата вылета в начальное значение при ошибке ввода
	function RESET_BLEED_VAL()
	{
		BLEED_VAL.text = the_artboard_offset;
		BLEED_VAL.active = true;
		return;
	};// end RESET_BLEED_VAL
	//
	// подпрограмма ввода вылета в процессе ввода
	function BLEED_VAL_ON_CHANGING()
	{
		var d = GET_NUMBER_ON_INPUT( BLEED_VAL.text );
		if( exit_if_bad_input )
		{
			RESET_BLEED_VAL();
		};// if
		if( d < -0. || BLEED_VAL.text == "-") 
		{
			alert("Bad artboard bleed!");
			RESET_BLEED_VAL();	
		};// if
		if(BLEED_VAL.text == "" || BLEED_VAL.text == " ") BLEED_VAL.text = "0";
		return;
	};// end BLEED_VAL_ON_CHANGING
	//
	// подпрограмма ввода вылета в результате ввода
	function BLEED_VAL_ON_CHANGE()
	{
		CHECK_ZERO_TEXT( BLEED_VAL );
		return;
	};// end BLEED_VAL_ON_CHANGE
	// обновляем поля для вылета
	UNITS_DROP_ON_CHANGE();
	//
	//----------------------------------------------------------------------------
	MAKE_LINE_IN_DIALOG(dlg);
	// группа опций
	dlg.OPT_GROUP = dlg.add('group');
	dlg.OPT_GROUP.orientation = 'column';
	dlg.OPT_GROUP.alignChildren = 'left';
	// чекбокс для копии
	dlg.OPT_GROUP.copy_cb = dlg.OPT_GROUP.add('checkbox');
	COPY = dlg.OPT_GROUP.copy_cb;
	COPY.text = "Make copy of guide for selected direction if non-zero shift"; 
	COPY.enabled = false;
	// учет клипмаски
	if( CLIP ) {
		dlg.OPT_GROUP.CM =  dlg.OPT_GROUP.add('checkbox');
		dlg.OPT_GROUP.CM.text = "Consider clipping mask";
		dlg.OPT_GROUP.CM.value = true;
		CM_OLD = dlg.OPT_GROUP.CM.value;
		MAKE_SELECTION( NO_CLIP_OBJ_TO_SHOW );
		dlg.OPT_GROUP.CM.onClick = CM_ON_CLICK;
		function CM_ON_CLICK()
		{
			CM_OLD = dlg.OPT_GROUP.CM.value;
			if( CM_OLD ) MAKE_SELECTION( NO_CLIP_OBJ_TO_SHOW )
			else MAKE_SELECTION( sel_init );
			return;
		};// end CM_ON_CLICK
	};// if
	// премещение направляющих
	if( AD.layers.length > 1 ) {
		MOVE_ALL_GUIDES = dlg.OPT_GROUP.add('checkbox');
		MOVE_ALL_GUIDES.text = "Move all guides in the document to selected layer";
	};// if
	//
	// выделить все направляющие
	var sel_group = dlg.OPT_GROUP.add('group');
	sel_group.orientation = 'row';
	sel_group.alignChildren = 'left';
	SEL_ALL_GUIDES = sel_group.add('checkbox');
	SEL_ALL_GUIDES.text = "Select guides.";
	LOCKED_GUIDES = MAKE_DROP(sel_group, "Locked:", ["ignore", "include"]);
	LOCKED_GUIDES.maximumSize.width = 60;
	if( AD.layers.length > 1 ){ 
		LOCKED_LAYERS = MAKE_DROP(sel_group, "Locked layers:", ["ignore", "include"]);
		LOCKED_LAYERS.maximumSize.width = 60;
	};// if
	//-----------------------------------------------------------------------------------
	MAKE_LINE_IN_DIALOG(dlg.OPT_GROUP);
	//
	// удалить все направляющие
	var del_group = dlg.OPT_GROUP.add('group');
	del_group.orientation = 'row';
	del_group.alignChildren = 'left';
	DEL_GUIDES = del_group.add('checkbox');
	DEL_GUIDES.onClick = DEL_ON_CLICK;
	DEL_GUIDES.text = "Delete guides.";
	if( AD.layers.length > 1 ) {
		DEL_WHERE = MAKE_DROP(del_group, "All", ["in document", "on selected layer only"]);
	} else {
		DEL_WHERE = MAKE_DROP(del_group, "All", ["in document"]);
	};// if-else
	DROP_ACTIVE( DEL_WHERE, false );
	DEL_WHERE.maximumSize.width = 80;
	DEL_LOCKED = MAKE_DROP(del_group, "Locked guides:", ["include", "ignore"]);
	DROP_ACTIVE( DEL_LOCKED, false );
	DEL_LOCKED.maximumSize.width = 60;
	//
	function ACTIVE_DIR( dir, act ) {
		if( !act ) {
			dir[1].value = false;
			dir[0].text = "0";
		};// if
		dir[0].enabled = act; dir[1].enabled = act;
	return;
	};// end ACTIVE_DIR
	//
	function ACTIVE_CB( cb, act ) {
		cb.enabled = act;
		if( !act ) cb.value = false;
	return;
	};// end ACTIVE_CB
	//
	// получение номера акт. единиц
	function GET_UNITS_SELECTION ( u ) {
		if( u == "mm" ) return 0;
		if( u == "cm" ) return 1;
		if( u == "pt" ) return 2;
		if( u == "in" ) return 3;
		return 0;
	};// GET_UNITS_SELECTION
	//
	function DEL_ON_CLICK() {
		function ACTIVE( act ) {
			if( CLIP ) {
				dlg.OPT_GROUP.CM.enabled = act;
			}
			ACTIVE_CB( SEL_ALL_GUIDES, act );
			dlg.mainpanel.enabled = act;
			dlg.bleed_pan.enabled = act;
			DROP_ACTIVE( DEL_WHERE, !act );
			DROP_ACTIVE( DEL_LOCKED, !act );
			ACTIVE_DIR( dlg_LEFT, act );
			ACTIVE_DIR( dlg_RIGHT, act );
			ACTIVE_DIR( dlg_TOP, act );
			ACTIVE_DIR( dlg_BOTTOM, act );
			ACTIVE_DIR( dlg_CV, act );
			ACTIVE_DIR( dlg_CH, act );
			DROP_ACTIVE( OBJ_DROP, act );
			SYM_BLEED.enabled = act;
			if( !act ) {
				COPY.enabled = act;
				COPY.value = act;
			};
			if(SYM_BLEED.value) SYM_BLEED.value = act;
			SYM_BLEED_onClick();
			SYM_BLEED_TEXT_1.enabled = act;
			SYM_BLEED_TEXT_2.enabled = act;
			if( N_sel > 0 ) DROP_ACTIVE( BOUNDS_DROP, act );
			if( !act ) {
				UNITS = UNITS_DROP.selection.text;
			};
			DROP_ACTIVE( UNITS_DROP, act );
			if( act ) {
				UNITS_DROP.selection = GET_UNITS_SELECTION ( UNITS );
				ACTIVE_CB( dlg.OPT_GROUP.copy_cb, !act );
			};// if
			dlg.B_panel.enabled = act;
			if( AD.layers.length > 1 )
			{
				ACTIVE_CB( MOVE_ALL_GUIDES, act );
			}
			if( AD.layers.length > 1 ) DROP_ACTIVE( LOCKED_LAYERS, act );
			DROP_ACTIVE( LOCKED_GUIDES, act );
			sel_group.enabled = act;
			dlg_LEFT[2].enabled=dlg_RIGHT[2].enabled=dlg_TOP[2].enabled=dlg_BOTTOM[2].enabled=dlg_CV[2].enabled=dlg_CH[2].enabled=act;
			dlg_LEFT[3].enabled=dlg_RIGHT[3].enabled=dlg_TOP[3].enabled=dlg_BOTTOM[3].enabled=dlg_CV[3].enabled=dlg_CH[3].enabled=act;
		return;
		};// end ACTIVE
		//
		ACTIVE( !DEL_GUIDES.value );
	return;
	};// end DEL_ON_CLICK
	// создание панели кнопок (кнопка ОК, кнопка Cancel)
	//-----------------------------------------------------------------------------------
	MAKE_LINE_IN_DIALOG( dlg );
	dlg.okPanel = dlg.add('group');
	dlg.okPanel.orientation = 'row';
	dlg.okPanel.okBtn = dlg.okPanel.add('button', undefined, 'OK');// кнопка ОК
	dlg.okPanel.cancelBtn =dlg.okPanel.add('button',undefined, 'Cancel');// кнопка Cancel
	//
	// сделать черту
	function MAKE_LINE_IN_DIALOG( W ){
		var the_line = W.add('panel')
		the_line.bounds = [mp_left, undefined, mp_right, undefined];
	return;
	};// end MAKE_LINE_IN_DIALOG
	//
	// подпрограмма деактивации / активации списка
	function DROP_ACTIVE( the_drop, act ) {
		var NA;
		if( !act ) {
			if( !the_drop.enabled ) return;
			NA = the_drop.add('item', "N/A");
			NA.selected = true;
			the_drop.enabled = false;
		} else {
			try {
				if( the_drop.enabled ) return;
				the_drop.remove(  the_drop.items[the_drop.items.length-1]  );
				the_drop.items[0].selected = true;
				the_drop.enabled = true;
			} catch ( error ) {};
		};
	return;
	};// end DROP_ACTIVE
	// закрвываем окно ожидания
	WAIT( "", false );
	//
	// собственно показываем окно диалога
	var DIALOG_BUTTON = dlg.show();
	// если выбрана первая кнопка (ОК) выполняем построение напр.
	if (DIALOG_BUTTON == 1) {
		// выводим окно ожидания
		WAIT("Processing. Please wait...      ", true);
		// собственно выполнение
		ADDING();
		// закрываем окно ожидания
		WAIT("", false);
	};// if DIALOG_BUTTON == 1
	if (DIALOG_BUTTON == 2) 
	{
		NO_OPERATION = true;
	}
	if( CLIP ) MAKE_SELECTION( sel_init );
	REPORT( true );
}// if CHECK_SELECTION()
// воссстанавливаем старые настройки
RESTORE_OLD_DOC_SETTINGS();
return;
}//end main()
//
// продпрограмма выполнения скрипта (в диалоге был ОК)
function ADDING() {
	// получаем единицы
	UNITS = GET_UNITS_DROP( UNITS_DROP.selection );
	// присваиваем значения из диалога
	// направления
	var LEFT = dlg_LEFT[1].value;
	var RIGHT = dlg_RIGHT[1].value;
	var TOP = dlg_TOP[1].value;
	var BOTTOM = dlg_BOTTOM[1].value;
	var CV = dlg_CV[1].value; 
	var CH = dlg_CH[1].value;
	SHIFT_LEFT = TEXT_TO_POINTS(dlg_LEFT[0].text);
	SHIFT_RIGHT = TEXT_TO_POINTS(dlg_RIGHT[0].text);
	SHIFT_TOP = TEXT_TO_POINTS(dlg_TOP[0].text);
	SHIFT_CV = TEXT_TO_POINTS(dlg_CV[0].text);
	SHIFT_CH = TEXT_TO_POINTS(dlg_CH[0].text);
	SHIFT_BOTTOM = TEXT_TO_POINTS(dlg_BOTTOM[0].text);
	COPY = COPY.value;
	if( AD.layers.length > 1 ) {
		SL = AD.layers[LAYERS_DROP.selection];
		MOVE_ALL_GUIDES = MOVE_ALL_GUIDES.value;
		LOCKED_LAYERS = LOCKED_LAYERS.selection;
		if( LOCKED_LAYERS == 0 ) LOCKED_LAYERS = false else LOCKED_LAYERS = true;
	} else {
		SL = AL;
		MOVE_ALL_GUIDES = false;
		LOCKED_LAYERS = false;
	};// if-else	
	SEL_ALL_GUIDES = SEL_ALL_GUIDES.value;
	LOCKED_GUIDES = LOCKED_GUIDES.selection;
	if( LOCKED_GUIDES == 0 ) LOCKED_GUIDES = false else LOCKED_GUIDES = true;
	SL_visible = SL.visible;
	SL_locked = SL.locked;
	if( SHIFT_LEFT != 0. || SHIFT_RIGHT != 0. || SHIFT_TOP != 0. || 
	     SHIFT_CV != 0. || SHIFT_CH != 0. || SHIFT_BOTTOM != 0. ) NON_ZERO_SHIFT = true;
	     DIR_SELECTED = LEFT+RIGHT+TOP+BOTTOM+CV+CH;
	if( DIR_SELECTED == 0 ) DIR_SELECTED = false else DIR_SELECTED = true;
	if( DIR_SELECTED || MOVE_ALL_GUIDES ) {
		if( !SL.visible || SL.locked ) {
			SL.visible = true;
			SL.locked = false;
			NO_CLOSE_SL = true;
		};
	};// 
	DEL_GUIDES = DEL_GUIDES.value;
	DEL_WHERE = DEL_WHERE.selection.text;
	DEL_LOCKED = DEL_LOCKED.selection.text;
	the_artboard_offset = TEXT_TO_POINTS ( BLEED_VAL.text );
	//
	if( !DIR_SELECTED && !MOVE_ALL_GUIDES && !SEL_ALL_GUIDES && !DEL_GUIDES ) {
		WAIT("", false);
		alert("No executable options were selected!");
		return;
	};
	if ( DEL_GUIDES ) {
		OPEN_LAYERS( false );
		var AD_guides = new Array();
		// наполняем массив направляющих
		for( var i = 0; i < AD.pathItems.length; i++ ) {
			if( AD.pathItems[i].guides) AD_guides.push( AD.pathItems[i] );
		};// for
		// обрабатываем массив (удаляем )
		for( var i = AD_guides.length - 1; i >= 0; i--) {
			var the_guide = AD_guides[i];
			var the_layer = the_guide.layer;
			if( (DEL_WHERE == "on selected layer only") && the_layer != SL) continue;
			if( the_guide.locked ) {
				 if( DEL_LOCKED != "include" ) continue;
				the_guide.locked = false;
			};// if
			try {
				the_guide.remove();
				N_DEL = N_DEL + 1;
			} catch ( error ) {};
		};// for
	if ( N_DEL > 0 ) RESTORE_LAYERS( false )
	else RESTORE_LAYERS( true );
	return;
	};// if DEL_GUIDES
	if( CLIP ) MAKE_BY_CLIP = dlg.OPT_GROUP.CM.value;
	// если все считаем по клип. маске
	if( MAKE_BY_CLIP ) {
		v_sel_left = NC_v_left;
		g_sel_left = NC_g_left;
		v_sel_right = NC_v_right;
		g_sel_right = NC_g_right;
		v_sel_top = NC_v_top;
		g_sel_top = NC_g_top;
		v_sel_bottom = NC_v_bottom;
		g_sel_bottom = NC_g_bottom;
	}// if
	var OBJ_DROP_SEL = OBJ_DROP.selection.text;
	if( OBJ_DROP_SEL == "Entire selection" || OBJ_DROP_SEL == "Selected object" ) MAKE_WHOLE_SEL = true;
	if( OBJ_DROP_SEL == "Each object in selection" ) MAKE_EACH_OBJ = true;
	if( OBJ_DROP_SEL == "Artboard" ) MAKE_ARTBOARD = true;
	// получаем значение для выбора границ из диалога (геометрич. - истина)
	if( !MAKE_ARTBOARD) {
		if( BOUNDS_DROP.selection.text == "Geometric" ) the_geometric_bounds = true
		else the_geometric_bounds = false;
	};// if
	// получаем размеры документа
	AD_height = AD.height;
	AD_width = AD.width;
	// определяем габариты всего выделения
	// геометрические
	g_sel_bottom_entire = MIN_IN_ARRAY(g_sel_bottom);
	g_sel_top_entire = MAX_IN_ARRAY(g_sel_top);
	g_sel_left_entire = MIN_IN_ARRAY(g_sel_left);
	g_sel_right_entire = MAX_IN_ARRAY(g_sel_right);
	// визуальные
	v_sel_bottom_entire = MIN_IN_ARRAY(v_sel_bottom);
	v_sel_top_entire = MAX_IN_ARRAY(v_sel_top);
	v_sel_left_entire = MIN_IN_ARRAY(v_sel_left);
	v_sel_right_entire = MAX_IN_ARRAY(v_sel_right);
	//
	// если геометрические границы
	if (the_geometric_bounds) 
	{
		// если ниже
		if( g_sel_bottom_entire < 0. ) dy_rulers_bottom = - (g_sel_bottom_entire);
		// если выше
		if( g_sel_top_entire > AD_height ) dy_rulers_top = (g_sel_top_entire - AD_height);
		// если влево
		if( g_sel_left_entire < 0. ) dx_rulers_left = - (g_sel_left_entire);
		// если вправо
		if( g_sel_right_entire > AD_width ) dx_rulers_right = (g_sel_right_entire - AD_width);
	} 
	// если визуальные границы
	else 
	{
		// если ниже
		if( v_sel_bottom_entire < 0. ) dy_rulers_bottom = - (v_sel_bottom_entire);
		// если выше
		if( v_sel_top_entire > AD_height ) dy_rulers_top = (v_sel_top_entire - AD_height);
		// если влево
		if( v_sel_left_entire < 0. ) dx_rulers_left = - (v_sel_left_entire);
		// если вправо
		if( v_sel_right_entire > AD_width ) dx_rulers_right = (v_sel_right_entire - AD_width);
	}// if
	// строим направляющие в соответствии с данными 
	// из диалога и координатами выделения
	// каждый объект
	var the_left, the_right, the_top, the_bottom, the_cv, the_ch;
	if( MAKE_EACH_OBJ ) {
		for( var i=0; i < N_sel; i++ ) {
			if (the_geometric_bounds) {
				the_left =  g_sel_left[i]; 
				the_top = g_sel_top[i]; 
				the_right = g_sel_right[i]; 
				the_bottom =g_sel_bottom[i];
				} else {
				the_left =  v_sel_left[i]; 
				the_top = v_sel_top[i]; 
				the_right = v_sel_right[i]; 
				the_bottom =v_sel_bottom[i];
			}// if
			if (LEFT) {
				make_vertical_guide ( the_left+SHIFT_LEFT ); 
				if( SHIFT_LEFT != 0. && COPY) make_vertical_guide ( the_left );
			}			
			if (RIGHT) {
				make_vertical_guide ( the_right+SHIFT_RIGHT );
				if( SHIFT_RIGHT != 0. && COPY) make_vertical_guide ( the_right );
			}
			if (TOP) {
				make_horizontal_guide ( the_top+SHIFT_TOP );
				if( SHIFT_TOP != 0. && COPY) make_horizontal_guide ( the_top );
			}
			if (BOTTOM) {
				make_horizontal_guide ( the_bottom+SHIFT_BOTTOM );
				if( SHIFT_BOTTOM != 0. && COPY) make_horizontal_guide ( the_bottom );
			}
			if (CH) {
				make_horizontal_guide ( (the_bottom + ((the_top - the_bottom )/2.)) + SHIFT_CH);
				if( SHIFT_CH != 0. && COPY) make_horizontal_guide ( ( the_bottom + ((the_top - the_bottom )/2.)));
			}
			if (CV) {
				make_vertical_guide ( (the_left + ((the_right - the_left)/2.))+ SHIFT_CV);
				if( SHIFT_CV != 0. && COPY) make_vertical_guide ( ( the_left + ((the_right - the_left)/2.) ));
			}
		}// for i
	}// if
	// все выделение
	if( MAKE_WHOLE_SEL ) {
			if (the_geometric_bounds) {
				the_left = g_sel_left_entire;
				the_top = g_sel_top_entire;
				the_right = g_sel_right_entire;
				the_bottom = g_sel_bottom_entire;
			} else {
				the_left = v_sel_left_entire;
				the_top = v_sel_top_entire;
				the_right = v_sel_right_entire;
				the_bottom = v_sel_bottom_entire;
			}// if
			if (LEFT) {
				make_vertical_guide ( the_left+SHIFT_LEFT ); 
				if( SHIFT_LEFT != 0. && COPY) make_vertical_guide ( the_left );
			}			
			if (RIGHT) {
				make_vertical_guide ( the_right+SHIFT_RIGHT );
				if( SHIFT_RIGHT != 0. && COPY) make_vertical_guide ( the_right );
			}
			if (TOP) {
				make_horizontal_guide ( the_top+SHIFT_TOP );
				if( SHIFT_TOP != 0. && COPY) make_horizontal_guide ( the_top );
			}
			if (BOTTOM) {
				make_horizontal_guide ( the_bottom+SHIFT_BOTTOM );
				if( SHIFT_BOTTOM != 0. && COPY) make_horizontal_guide ( the_bottom );
			}
			if (CH) {
				make_horizontal_guide ( (the_bottom + ((the_top - the_bottom )/2.)) +SHIFT_CH );
				if( SHIFT_CH != 0. && COPY) make_horizontal_guide ( ( the_bottom + ((the_top - the_bottom )/2.)));
			}
			if (CV) {
				make_vertical_guide ( (the_left + ((the_right - the_left)/2.)) + SHIFT_CV);
				if( SHIFT_CV != 0. && COPY) make_vertical_guide ( ( the_left + ((the_right - the_left)/2.)));
			}
	}//if
	// артборд
	if (MAKE_ARTBOARD) 
	{
			dy_rulers_bottom = dy_rulers_top = dx_rulers_left = dx_rulers_right = 0.;
			if (LEFT) {
				make_vertical_guide ( SHIFT_LEFT ); 
				if( SHIFT_LEFT != 0. && COPY) make_vertical_guide (0 );
			}
			if (RIGHT) {
				make_vertical_guide ( AD_width+SHIFT_RIGHT );
				if( SHIFT_RIGHT != 0. && COPY) make_vertical_guide ( AD_width );
			}
			if (TOP) {
				make_horizontal_guide ( AD_height+SHIFT_TOP );
				if( SHIFT_TOP != 0. && COPY) make_horizontal_guide ( AD_height );
			}
			if (BOTTOM) {
				make_horizontal_guide ( SHIFT_BOTTOM );
				if( SHIFT_BOTTOM != 0. && COPY) make_horizontal_guide (0 );
			}
			if (CH) {
				make_horizontal_guide ( ( AD_height/2. )+SHIFT_CH );
				if( SHIFT_CH != 0. && COPY) make_horizontal_guide (( AD_height/2. ) );
			}
			if (CV) {
				make_vertical_guide ( ( AD_width/2. )+SHIFT_CV );
				if( SHIFT_CV != 0. && COPY) make_vertical_guide (( AD_width/2. ));
			}
	}// if
	//
	// преремещаем направляющие на выбранный слой
	if( MOVE_ALL_GUIDES ) MOVE_GUIDES();
	function MOVE_GUIDES() {
		OPEN_LAYERS( false );
		var AD_guides = new Array();
		for( var i = 0; i < AD.pathItems.length; i++ ) {
			if( AD.pathItems[i].guides) AD_guides.push( AD.pathItems[i] );
		};// for
		for( var i=0; i < AD_guides.length; i++) {
			var locked = false;
			if( AD_guides[i].locked ) {
				locked = true;
				AD_guides[i].locked = false;
			};// if
			try {
				AD_guides[i].move(SL, ElementPlacement.INSIDE);
				N_MOVED = N_MOVED + 1;
			} catch ( error ) {};
			if( locked ) {
				AD_guides[i].locked = true;
			};// if
		};// for
	if ( N_MOVED > 0 ) RESTORE_LAYERS( false )
	else RESTORE_LAYERS( true );
	return;
	};// end MOVE_GUIDES
	//
	// выделяем направляющие
	if( SEL_ALL_GUIDES ) SEL_GUIDES_SUB();
	function SEL_GUIDES_SUB() {
		AD.selection = null;
		var AD_guides = new Array();
		// цикл по объектам
		for( var i = 0; i < AD.pathItems.length; i++ ) {
			if( AD.pathItems[i].guides) AD_guides.push(AD.pathItems[i]);
		};// for
		// цикл по направляющим
		for(  var i = AD_guides.length - 1; i >= 0; i-- ) {
			var the_guide = AD_guides[i];
			var the_layer = the_guide.layer;
			// если не ищем на закрытых слоях возврат
			if( (!the_layer.visible || the_layer.locked) && !LOCKED_LAYERS ) continue;
			// если не ищем заблокированные направляющие возврат
			if( the_guide.locked && !LOCKED_GUIDES ) continue;
			// если слой закрыт или заблокирован открываем
			if( !the_layer.visible || the_layer.locked ) {
				// если это был выделенный слой
				if( the_layer == SL ) NO_CLOSE_SL = true;
				the_layer.visible = true;
				the_layer.locked = false;
			};// if
			// если направляющая заблокирована разблокируем
			if( the_guide.locked ) the_guide.locked = false;
			// выделяем направляющую
			try {
				the_guide.selected = true;
				if( the_guide.selected ) N_SELECTED = N_SELECTED + 1;
			} catch (error ) {};
		};// for
	return;
	};// end SEL_GUIDES_SUB
return;
}// end ADDING()
//
//подпрограмма открывания слоев
function OPEN_LAYERS( OPEN_SL ) {
	for(var i=0; i < AD.layers.length; i++) {
		if( AD.layers[i] == SL && OPEN_SL ) continue;
		LL[i] = AD.layers[i].locked;
		AD.layers[i].locked = false;
		LV[i] = AD.layers[i].visible;
		AD.layers[i].visible = true;
	};// for
	LAYERS_WERE_OPEN = true;
return;
};// end OPEN_LAYERS
//
// подпрограмма восстановления настроек слоев
function RESTORE_LAYERS( CLOSE_SL ) {
	for(var i=0; i < AD.layers.length; i++) {
		if( AD.layers[i] == SL && CLOSE_SL ) continue;
			AD.layers[i].locked = LL[i];
			AD.layers[i].visible = LV[i];
	};// for	
	LAYERS_WERE_OPEN = false;
return;
};// end RESTORE_LAYERS
//
// подпрограмма запоминания настроек слоев
function REMEMBER_LAYERS() {
	for(var i=0; i < AD.layers.length; i++) {
		LL[i] = AD.layers[i].locked;
		LV[i] = AD.layers[i].visible;
	};// for
return;
};// end REMEMBER_LAYERS
//
// подпрограмма проверки выделения
function CHECK_SELECTION() {
	// выводим окно ожидания
	WAIT( "Getting information. Please wait...", true );
	// есть ли открытые документы
	N_doc = app.documents.length;
	if (N_doc < 1 ) {
		WAIT( "", false );
		alert( "There are no open documents!");
			NO_DOC = true;
		return false;
	};// if
	// есть ли выделенные объекты
	AD = app.activeDocument;
	AL = AD.activeLayer;
	the_sel = AD.selection;
	N_sel = the_sel.length;
	// сохраняем старые настройки
	SAVE_OLD_DOC_SETTINGS();
	// есть ли направляющие в выделении
	if( GUIDES_IN_SELECTION() ) {
		WAIT( "", false );
		 alert("There are some selected guides!"+BL+"Can not process that!");
		 exit_if_bad_sel = true;
		 return false;
	};// if
	// устанавливаем все координаты в ноль принудительно
	// смещения координат в ноль
	AD.rulerOrigin =  [0.,0.];
	AD.pageOrigin = [0.,0.];
	//получаем размеры выделения
	SELECTION_DIM();
	if(exit_if_bad_sel) {
		WAIT( "", false );
		alert("Can not process the selection!");
		return false;
	};// if
	sel_init = the_sel;
return true;
}// end CHECK_SELECTION()
//
// подпрограмама поиска направляющих в выделении
function GUIDES_IN_SELECTION() {
	function GUIDES_INSIDE( the_obj ) {
	if( IS_GUIDE( the_obj ) ) return true;
	try {
		for( var i =0; i < the_obj.pageItems.length; i++ ) {
			if( GUIDES_INSIDE( the_obj.pageItems[i] ) ) return true;
		};// for
	} catch( error) {}
	return false;
	};// end GUIDES_INSIDE
	for( var i=0; i < the_sel.length; i++ ){
		if( GUIDES_INSIDE( the_sel[i] ) ) return true;
	}
return false;
};// end GUIDES_IN_SELECTION
//
// подпрограмма вычисления размеров выделения
function SELECTION_DIM() {
// начальное присвоение крайних значений
// для каждого объекта в выделении
for(var i=0; i < N_sel; i++) {
	var the_obj = the_sel[i];
	// получаем общие границы выделенного объекта
	var sel_bounds = new Array();
	sel_bounds = SEL_BOUNDS ( the_obj );
	if( sel_bounds == false ) {
		exit_if_bad_sel = true;
		return;
	};// if
	if( IS_GUIDE(the_obj) ) return;
	// геометрические
	g_sel_left[i] = sel_bounds[0];
	g_sel_top[i] =  sel_bounds[1];
	g_sel_right[i] =  sel_bounds[2];
	g_sel_bottom[i] =  sel_bounds[3];
	// визуальные
	v_sel_left[i] = sel_bounds[4];
	v_sel_top[i] =  sel_bounds[5];
	v_sel_right[i] =  sel_bounds[6];
	v_sel_bottom[i] =  sel_bounds[7];
	//
	// с учетом клип маски
	var nc_bounds = new Array(); 
	nc_bounds = NO_CLIP_BOUNDS (the_obj);
	// геом. границы
	NC_g_left[i] = nc_bounds[0];
	NC_g_top[i] = nc_bounds[1];
	NC_g_right[i] = nc_bounds[2];
	NC_g_bottom[i] = nc_bounds[3];
	// визуальные границы
	NC_v_left[i] = nc_bounds[4];
	NC_v_top[i] = nc_bounds[5];
	NC_v_right[i] = nc_bounds[6];
	NC_v_bottom[i] = nc_bounds[7];
	//
	if( (g_sel_left[i] != NC_g_left[i]) || (g_sel_top[i] != NC_g_top[i]) || (g_sel_right[i] != NC_g_right[i]) || (g_sel_bottom[i] != NC_g_bottom[i]) ||
	     (v_sel_left[i] != NC_v_left[i]) || (v_sel_top[i] != NC_v_top[i]) || (v_sel_right[i] != NC_v_right[i]) || (v_sel_bottom[i] != NC_v_bottom[i]) ) {
		     CLIP = true;
	}// if  
}// for i
return;
}// end SELECTION_DIM
//
// подпрограмма построения вертикальной направляющей
function make_vertical_guide( x ) {
	DONE_OK = true;
	if(isNaN( x ) ) {
		DONE_OK = false;
		return;
	};// if
	try {
	var the_guide = make_line_for_guide();
	var top = AD_height + dy_rulers_top + the_artboard_offset;
	var bottom = - dy_rulers_bottom - the_artboard_offset;
	the_guide.setEntirePath([[x, top], [x, bottom]]);
	N_MADE = N_MADE + 1;
	} catch ( error ) {};
return;
}// end make_vertical_guide
//
// подпрограмма построения горизонтальной направляющей
function make_horizontal_guide( y ) {
	DONE_OK = true;
	if(isNaN( y ) ) {
		DONE_OK = false;
		return;
	};// if
	try {
	var the_guide = make_line_for_guide();
	var left = - dx_rulers_left - the_artboard_offset;
	var right = AD_width + dx_rulers_right + the_artboard_offset;
	the_guide.setEntirePath([[left, y], [right, y]]);
	N_MADE = N_MADE + 1;
	} catch ( error ) {};
return;
}// end make_horizontal_guide
//
// подпрограмма создания заготовки для направляющей
function make_line_for_guide() {
	var the_guide = SL.pathItems.add();
	the_guide.guides = true;
	the_guide.stroked = false;
	the_guide.filled = false;
return the_guide;
}// end make_line_for_guide
//
// подпрограмма сохранения старых настроек док-та
function SAVE_OLD_DOC_SETTINGS() {
	AD_old_ruler_origin = AD.rulerOrigin;
	AD_old_page_origin = AD.pageOrigin;
	REMEMBER_LAYERS();
return; 
}//end SAVE_OLD_DOC_SETTINGS
//
// подпрограмма восстановления старых настроек док-та
function RESTORE_OLD_DOC_SETTINGS() {
	if( NO_DOC ) return;
	AD.rulerOrigin = AD_old_ruler_origin;
	AD.pageOrigin = AD_old_page_origin;
	//
	if( NO_OPERATION || exit_if_bad_sel ) return;
	//
	if( !NO_CLOSE_SL ) {
		SL.visible = SL_visible;
		SL.locked = SL_locked;
	};// if
return; 
}// end RESTORE_OLD_DOC_SETTINGS()
//
// функция чтения текстового ввода и перевода в число
function TEXT_TO_DIGIT ( txt ) {
	var d = txt.toLowerCase();
	var k = 1.;
	if( UNITS == 'pt' ) k = 1.; 
	if( UNITS == 'in' ) k = 72.; 
	if( UNITS == 'mm' ) k = 72./25.4; 
	if( UNITS == 'cm' ) k = (72./25.4)*10.;
	d = parseFloat( txt ) * k;
	// если не цифра, обнуляем
	 if( isNaN(d) ) {
		 d = 0.;
		 exit_if_bad_input = true;
	}
	// возвращаем значение в пунктах для расчета
return d;
}// end TEXT_TO_DIGIT
//
// подпрограмма определения границ того что не в масках
// возвращает массив границ
// в ней еще есть подпрограмма создания массивов границ того что не в масках
function NO_CLIP_BOUNDS (the_obj) {
	// определяем массив объектов вне масок
	var NO_CLIP_OBJECTS = new Array();
	// получаем массив объектов вне масок
	GET_NO_CLIP_OBJECTS ( the_obj );
	// определяем массивы границ объектов вне масок
	var v_left =  new Array();
	var g_left = new Array();
	var v_top =  new Array();
	var g_top = new Array();
	var v_right =  new Array();
	var g_right = new Array();
	var v_bottom =  new Array();
	var g_bottom = new Array();
	// заполняем массивы границ объектов вне масок
	for (var i=0; i < NO_CLIP_OBJECTS.length; i++) {
		g_left[i] = NO_CLIP_OBJECTS[i].geometricBounds[0];
		v_left[i] = NO_CLIP_OBJECTS[i].visibleBounds[0];
		g_top[i] = NO_CLIP_OBJECTS[i].geometricBounds[1];
		v_top[i] = NO_CLIP_OBJECTS[i].visibleBounds[1];
		g_right[i] = NO_CLIP_OBJECTS[i].geometricBounds[2];
		v_right[i] = NO_CLIP_OBJECTS[i].visibleBounds[2];
		g_bottom[i] = NO_CLIP_OBJECTS[i].geometricBounds[3];
		v_bottom[i] = NO_CLIP_OBJECTS[i].visibleBounds[3];
	}// for
	// вычисляем результирующие границы объектов вне масок
	var v_L = MIN_IN_ARRAY ( v_left );
	var g_L = MIN_IN_ARRAY ( g_left );
	var v_T = MAX_IN_ARRAY ( v_top );
	var g_T = MAX_IN_ARRAY ( g_top );
	var v_R = MAX_IN_ARRAY ( v_right );
	var g_R = MAX_IN_ARRAY ( g_right );
	var v_B = MIN_IN_ARRAY ( v_bottom );
	var g_B = MIN_IN_ARRAY ( g_bottom );
return [g_L, g_T, g_R, g_B, v_L, v_T, v_R, v_B];
//
// подпрограмма занесения в массив объектов вне маски
// (вложена в подпрограмму NO_CLIP_BOUNDS)
function GET_NO_CLIP_OBJECTS ( the_obj ) {
	// если объект клип. маска
	if (IS_CLIP (the_obj)) {
		// заносим в массив только сам контур клип. маски  и сразу возвращаемся!!!!
		// в этом ВСЯ фишка!!!!
		try {
			NO_CLIP_OBJECTS.push(the_obj.pathItems[0]);
			NO_CLIP_OBJ_TO_SHOW.push(the_obj.pathItems[0]);
		} catch ( error ) {};
		return;
	}// if
	// если группа, то просматриваем элементы группы
	if( the_obj.constructor.name == "GroupItem" ) {
		try {
			// определяем под-объекты в группе
			var N_sub_obj =  the_obj.pageItems.length;
			for (var i=0; i < N_sub_obj; i++) {
				GET_NO_CLIP_OBJECTS ( the_obj.pageItems[i] );
			}// for
		} catch (error) {}
		// если группа, то возврат здесь, чтобы не занести саму группу в массив
		return;
	}// if
	// заносим в массив объект 
	NO_CLIP_OBJECTS.push(the_obj);
	NO_CLIP_OBJ_TO_SHOW.push(the_obj);
return;
}// end GET_NO_CLIP_OBJECTS
}// end NO_CLIP_BOUNDS
//
// подпрограмма определения макс. значения в массиве
function MAX_IN_ARRAY ( the_array) {
	var MAX =  the_array[0];
	for ( var i = 0; i < the_array.length; i++ ) {
		if(  the_array[i] > MAX ) MAX =  the_array[i];
	}
return MAX;
}// end  MAX_IN_ARRAY
//
// подпрограмма определения мин. значения в массиве
function MIN_IN_ARRAY ( the_array) {
	var MIN =  the_array[0];
	for ( var i = 0; i < the_array.length; i++ ) {
		if(  the_array[i] < MIN ) MIN =  the_array[i];
	}
return MIN;
}// end MIN_IN_ARRAY
//
// подпрограмма получения границ по выделению
function SEL_BOUNDS ( the_obj ) {
	try {
	var g_L =  the_obj.geometricBounds[0];
	var v_L =  the_obj.visibleBounds[0];
	var g_T =  the_obj.geometricBounds[1];
	var v_T =  the_obj.visibleBounds[1];
	var g_R =  the_obj.geometricBounds[2];
	var v_R =  the_obj.visibleBounds[2];
	var g_B =  the_obj.geometricBounds[3];
	var v_B =  the_obj.visibleBounds[3];
	} catch ( error ) {
		return false
	};		
return [g_L, g_T, g_R, g_B,   v_L, v_T, v_R, v_B];
}// end SEL_BOUNDS
//
// подпрограмма определения является ли объект клип. группой
function IS_CLIP ( the_obj ) {
	try {
		if (the_obj.constructor.name == "GroupItem" ) {
			if( the_obj.clipped ) {
				return true;
			}
		}
	} catch (error) {};
return false;
}// end  IS_CLIP
//
// продпрограмма определения является ли объект направляющей
function IS_GUIDE ( the_obj ) {
	try {
		if (the_obj.guides)  {
			return true;
		}
	} catch (error) {};
return false;
}// end  IS_GUIDE
// подпрограмма вывода сообщения о выполнении
function REPORT( say ) {
	var S = "";
	if( (DIR_SELECTED == true ) && ( N_MADE == 0 ) ) {
		S = S + "No guides were made!\n";
	};// if
	if( (MOVE_ALL_GUIDES == true) && ( N_MOVED == 0 )) {
		S = S + "No guides were moved!\n";
	};// if
	if( (SEL_ALL_GUIDES == true) && ( N_SELECTED == 0 )) {
		S = S + "No guides were selected!\n";
	};// if
	if( (DEL_GUIDES == true) && ( N_DEL == 0 )) {
		S = S + "No guides were deleted!\n";
	};// if
	if( say ) {
		if(  S != "" ) alert(S);
	};// if
return;
};// end REPORT
//
// подпрограмма получения активных единиц
function GET_ACTIVE_UNITS() {
	var AD_units = app.activeDocument.rulerUnits;
	if( AD_units == RulerUnits.Millimeters ) return ["mm", 0];
	if( AD_units == RulerUnits.Centimeters ) return ["cm", 1];
	if( AD_units == RulerUnits.Points ) return ["pt", 2];
	if( AD_units == RulerUnits.Inches ) return ["in", 3];
	return ["mm", 0];
};// end GET_ACTIVE_UNITS
//
// функция чтения текстового ввода в активных единицах и перевода в пункты
function TEXT_TO_POINTS ( txt ) {
	var d = txt.toLowerCase();
	var k = 1.;
	if(UNITS == 'pt' ) k = 1.; 
	if( UNITS == 'in' ) k = 72.; 
	if(UNITS == 'mm' ) k = (72./25.4); 
	if( UNITS == 'cm' ) k = ((72./25.4)*10.);
	d = parseFloat( TEXT_TO_DIGIT(txt) ) * k;
	// если не цифра, обнуляем
	 if( isNaN(d) ) {
		 d = 0.;
		 exit_if_bad_input = true;
		 return;
	}
	// возвращаем значение в пунктах для расчета
return d;
};// end TEXT_TO_POINTS
//
//
function GET_UNITS_DROP( N ) {
	if( N == 0 ) return "mm";
	if( N == 1 ) return "cm";
	if( N == 2 ) return "pt";
	if( N == 3 ) return "in";
	return "mm";
};// GET_ACTIVE_UNITS
//
// функция чтения текстового ввода и перевода в число
function TEXT_TO_DIGIT ( txt ) {
	exit_if_bad_input = false;
	var s = "";
	// если пусто то ноль
	if( txt == "" ) s = "0";
	if( txt == "+" ) s = "0";
	if( txt == "-" ) s = "0";
	var only_space = true;
	for( var i=0; i < txt.length; i++ ) {
		if( txt[i] != " " ) only_space = false;
		if( txt[i] == ",") s = s + "." else s = s + txt[i];
	};// for
	// если только пробелы то ноль
	if( only_space ) s = "0";
	if( s == ".")  s = "0";
	if( s == "-")  s = "0";
	var s1 = "";
	for( var i=0; i < s.length; i++ ) {
		if( s[i] == " " ) continue;
		s1 = s1 + s[i];
	};// for
	for( var i=0; i < s1.length; i++ ) {
		if( s1[i] != "-" &&  s1[i] != "+"  &&  s1[i] != "." && isNaN( parseFloat( s1[i]) ) ){ 
			 exit_if_bad_input = true;
			  return false;
		};// if
	};// for
	var d = parseFloat( s1 );
	// если не цифра, обнуляем
	 if( isNaN( d ) ) {
		 exit_if_bad_input = true;
		 return false;
	};// if
	// возвращаем значение в пунктах для расчета
return d;
}// end TEXT_TO_DIGIT
//
// подпрограмма получения числа из текстового ввода
// в процессе ввода
// подпрограмма получения числа из текстового ввода
// в процессе ввода
function GET_NUMBER_ON_INPUT( the_t ) {
	var t = "";
	var t_i;
	var N_C = 0;
	var N_P = 0;
	var N_M = 0;
	exit_if_bad_input = false;
	for(var i=0; i < the_t.length; i++) {
		t_i = the_t[i];
		if( t_i == "," ) t_i = ".";
		if( t_i == "." ) N_C = N_C +1;
		if( t_i == "-" ) N_M = N_M +1;
		if( t_i == "+" ) N_P = N_P +1;
		if( ( (t_i != "-" &&  t_i != "+" &&  t_i != "."  ) &&  NO_DIGIT_SYMBOL( t_i ) ) || 
			  N_C>1 || ((N_M+N_P) > 1) || ( (t_i == "-" || t_i == "+") && i != 0)
		  ) 
		{
			exit_if_bad_input = true;
			INP_OK = false;
			alert( "Bad number input" );
			return false;
		};
		t = t + t_i;
	};// for
	//t = parseFloat( t );
return t;
};// end GET_NUMBER_ON_INPUT
//
function NO_DIGIT_SYMBOL( s ) {
	try{
	if( s!= "0" && s!= "1" && s!= "2" && s!= "3" && s!= "4" && 
		s!= "5" && s!= "6" && s!= "7" && s!= "8" && s!= "9") return true;
	} catch( error ) {};
	return false;
};//
//
// подпрограмма проверки текстового ввода
// на наличие спецсимволов после ввода и установка в 0
function CHECK_ZERO_TEXT( the_obj ) {
var txt = the_obj.text;
if( txt == ""  ||
	txt == " "  ||
	txt == "-" ||
	txt == "+"||
	txt == "." ||
	txt == "," ) 
	{
		the_obj.text = "0";
	};// if
	return;
};// end TEXT_TO_ZERO
//
// подпрограмма вывода окна ожидания
function WAIT(msg, act)
{
	if( act )
	{
		WAIT_WINDOW = new Window('palette');
		WAIT_WINDOW.text = the_title +" is working";
		var txt = WAIT_WINDOW.add('statictext');
		txt.bounds = [0, 0, 180, 20];
		txt.alignChildren = 'center';
		txt.text = msg;
		WAIT_WINDOW.onClose = W_ON_CLOSE;
		WAIT_WINDOW.independent = true;
		WAIT_WINDOW.show();
	}
	else
	{
		try 
		{
			W_CLOSE();
		} 
		catch ( error ) {};// try-catch
	};// if-else
	return;
	//
	function W_CLOSE()
	{
		try
		{
			WAIT_WINDOW.close();
			WAIT_WINDOW.active = false;
			WAIT_WINDOW.enabled = false;
			WAIT_WINDOW.visible = false;
		} catch (error) {}
		return;
	};
	//
	function W_ON_CLOSE()
	{
		W_CLOSE();
		return;
	};
};// end WAIT
//
// подпрограмма снятия выделения
function DESELECT_ALL() {
	app.activeDocument.selection = null;
	app.redraw();
return;
}
//
// подпрограмма создания выделения
function MAKE_SELECTION( objects ) {
	DESELECT_ALL();
	app.activeDocument.selection = objects;
	app.redraw();
return;
}